//  

#include <mega8.h>
#include <delay.h>
#include <stdio.h>  
#include <string.h>
#include <math.h>
#include <lcd.h>
#include <eeprom.h>

#define clock 16000000UL                     //   


#asm
.equ __lcd_port=0x12                         //  PORTD    ( )
#endasm

//  ,   ..

short int res_ADC;                           //      
short int res_mas[10];                       //       
short int res_mas_vr[10];                    //       
short int i;                                 //  
short int res_sum;                           //         
short int res_sr;                            //        
float temp;                                  //      
char LCD_buf_1[16];                          //     
char LCD_buf_2[16];                          //                                               
short int res_led;                           //      
short int led_mas[10];                       //       
short int led_mas_vr[10];                    //        
short int led_sum;                           //         
short int led_sr;                            //       
short int porog;                             //    .      50
eeprom int porog_e;                          //      eeprom


//  ,    ..

void main(void)
{
delay_ms(5000);                              //   5         


//   

SFIOR |= (0<<ACME);                          // AIN1    AIN1
SFIOR |= (0<<PUD);                           //     
SFIOR |= (0<<PSR2);                          //   
SFIOR |= (0<<PSR10);                         //   
ADMUX |= (0<<REFS1) | (0<<REFS0);            //  AREF
ADMUX |= (1<<ADLAR);                         //   .   8 
ADMUX |= (0<<MUX3) | (0<<MUX2) | (0<<MUX1) | (0<<MUX0);    //  ADC0
ADCSRA |= (1<<ADEN);                          // 
ADCSRA |= (0<<ADSC);                          // 
ADCSRA |= (0<<ADFR);                          //   
ADCSRA |= (1<<ADIE);                          // 
ADCSRA |= (1<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);            //   16. 1   8  
DDRC.0=0;                                     // PC0  
   

//   
                                            
DDRD=0x00;                                     //  D  
PORTD=0x00;                                    //   D   0
lcd_init(16);                                  //    16   
lcd_clear();                                   //   
lcd_gotoxy(0,0);                               //       
sprintf(LCD_buf_1, "Temperature now");         //   Temperature now
lcd_puts(LCD_buf_1);                           //    


//        (    )

DDRC.5=1;                                      //  PC5  
PORTC.5=0;                                     //   PC5   0
DDRC.2=0;                                      //  PC2  
DDRC.3=0;                                      //  PC3  


//         " "  

for (i=0; i<10; i++)                           //    10 
{
delay_us(150);                                 //  150    
ADCSRA |= (1<<ADSC);                           //  
while((ADCSRA & 0x10)==0);                     //   
ADCSRA |= (0<<ADSC);                           //          
res_ADC=ADCH;                                  //  
res_mas[i]=res_ADC;                            //    
}


//         " "  

DDRC.4=0;                                      //  PC4  
ADMUX |= (0<<REFS1) | (1<<REFS0);              //    VCC
ADMUX &=0xF0;                                  //  4  MUX    
ADMUX |= (0<<MUX3) | (1<<MUX2) | (0<<MUX1) | (0<<MUX0);  //  ADC4
delay_us(150);                                 //  150    
for (i=0; i<10; i++)                           //    10 
{
delay_us(150);                                 //  150   
ADCSRA |= (1<<ADSC);                           //  
while((ADCSRA & 0x10)==0);                     //   
ADCSRA |= (0<<ADSC);                           //          
res_led=ADCH;                                  //  
led_mas[i]=res_led;                            //    
}


//    ( )

TCCR1A=(1<<COM1A1) | (0<<COM1A0) | (0<<WGM11) | (1<<WGM10);    //   -    "1",    OCR1A "0"
                                                               //   "0",   OCR1A "1".    
TCCR1B=(0<<WGM13) | (0<<WGM12);		                           //Phase Correct PWM
OCR1A=0x00;                                                    //      OCR1A (  0)
DDRB.1=1;                                                      //  PB1  
TCCR1B=(1<<CS12) | (0<<CS11) | (0<<CS10);                      //    256 ..   31.250  (..  Phase Correct PWM)


//    

WDTCR=(WDP2<<1) | (1<<WDP1) | (1<<WDP0);         //    128 ..     2 
WDTCR=(1<<WDE);                                  //  


//   

if (porog!=porog_e)                               
{
porog=porog_e;                                    //  porog    EEPROM  porog_e,     
}	                                              //      EEPROM   

		
// ,  

while (1)
{
delay_ms(200);                                  // ,       
res_sum=0;                                      //      
temp=0;                                         //   
led_sum=0;                                      //      



// ,     

ADMUX |= (0<<REFS1) | (0<<REFS0);               //    AREF
ADMUX &=0xF0;                                   //  4   MUX   
ADMUX |= (0<<MUX3) | (0<<MUX2) | (0<<MUX1) | (0<<MUX0);  //  PC0  
delay_us(150);                                   //  150    


//            

for (i=0; i<10; i++)
{
res_mas_vr[i]=res_mas[i];                       //         
}
for (i=0; i<9; i++)
{
res_mas[i]=res_mas_vr[i+1];                    //       ,   1- 
}                                              //( ,       0)


ADCSRA |= (1<<ADSC);                           //  
while((ADCSRA & 0x10)==0);                     //   
ADCSRA |= (0<<ADSC);                           //          
res_ADC=ADCH;                                  //  
res_mas[9]=res_ADC;                            //     


//  

for (i=0; i<10; i++)
{                          
res_sum=res_sum+res_mas[i];                    //   
}
res_sr=res_sum/10;                             //    10- 
temp=((0.0116470588*res_sr)-0.5)/0.01;         //  


//   

if (temp>porog)                                //      
{
sprintf(LCD_buf_2, "                ");        //   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //      2 
sprintf(LCD_buf_2, "WARNING t=%+.1f", temp);   //   WARNING temp   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //      2 
for (i=0; i<2000; i++)                         //  2000    ( )
{
PORTC.5=1;                                     //      PC5
delay_us(100);                                 //  100 
PORTC.5=0;                                     //     PC5
delay_us(100);                                 //  100 
#asm("wdr")                                    //   .
}                                              
}
else
{
sprintf(LCD_buf_2, "                ");        //   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //      2 
sprintf(LCD_buf_2, "t=%+.1f", temp);           //   temp   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //       
}


// ,     

ADMUX |= (0<<REFS1) | (1<<REFS0);              //     VCC
ADMUX &=0xF0;                                  //  4   MUX   
ADMUX |= (0<<MUX3) | (1<<MUX2) | (0<<MUX1) | (0<<MUX0);   // PC4  
delay_us(150);                                   //  150    


//            

for (i=0; i<10; i++)
{
led_mas_vr[i]=led_mas[i];                      //          
}
for (i=0; i<9; i++)
{
led_mas[i]=led_mas_vr[i+1];                    //       ,   1- 
}                                              //( ,       0)

ADCSRA |= (1<<ADSC);                           //  
while((ADCSRA & 0x10)==0);                     //   
ADCSRA |= (0<<ADSC);                           //          
res_led=ADCH;                                  //  
led_mas[9]=res_led;


//   

for (i=0; i<10; i++)
{                          
led_sum=led_sum+led_mas[i];                    //   
}
led_sr=led_sum/10;                             //    10- 
OCR1A=led_sr;                                  //     OCR1A ( )


#asm("wdr")                                    //   .       
                                               //..       delay_ms
                                                 
                                                                                             
//      

while (PINC.2==1 && PINC.3==0)                 //      PC2      PC3
{
if (porog<=120)                                //    - 
{
porog++;                                       //   porog  
sprintf(LCD_buf_2, "                ");        //   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //      2 
sprintf(LCD_buf_2, "Porog=%d",porog);          //   porog   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //       
delay_ms(250);                                 //  250 
#asm("wdr")                                    //   
}
else
{
porog=120;                                     //  porog   
sprintf(LCD_buf_2, "                ");        //   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //      2 
sprintf(LCD_buf_2, "Porog=%d",porog);          //   porog   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //       
delay_ms(250);                                 //  250 
#asm("wdr")                                    //   
}
}


while (PINC.2==0 && PINC.3==1)                 //      PC3      PC2
{
if (porog>=-40)                                //   - 
{
porog--;                                       //   porog  
sprintf(LCD_buf_2, "                ");        //   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //      2 
sprintf(LCD_buf_2, "Porog=%d",porog);          //   porog   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //       
delay_ms(250);                                 //  250 
#asm("wdr")                                    //   
}
else
{
porog=-40;                                     //  porog   
sprintf(LCD_buf_2, "                ");        //   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //      2 
sprintf(LCD_buf_2, "Porog=%d",porog);          //   porog   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //       
delay_ms(250);                                 //  250 
#asm("wdr")                                    //   
}
}


while (PINC.2==1 && PINC.3==1)                 //      PC3     PC2
{
sprintf(LCD_buf_2, "                ");        //   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //      2 
sprintf(LCD_buf_2, "Porog=%d",porog);          //   porog   
lcd_gotoxy(0,1);                               //       
lcd_puts(LCD_buf_2);                           //       
delay_ms(250);                                 //  250 
#asm("wdr")                                    //   
}


if(porog_e!=porog)                             
{
porog_e=porog;                                 //   porog_e  EEPROM   porog,      
}                                              //     EEPROM      
                                               //,          

}
}